开发人员手册

[![知识共享协议（CC协议）](https://img.shields.io/badge/License-Creative%20Commons-DC3D24.svg)](https://creativecommons.org/licenses/by-nc-sa/4.0/deed.zh)
[![GitHub stars](https://img.shields.io/github/stars/hbulpf/devbook.svg?label=Stars)](https://github.com/hbulpf/devbook)
[![GitHub watchers](https://img.shields.io/github/watchers/hbulpf/devbook.svg?label=Watchers)](https://github.com/hbulpf/devbook/watchers)
[![GitHub forks](https://img.shields.io/github/forks/hbulpf/devbook.svg?label=Forks)](https://github.com/hbulpf/devbook/fork)

# 1. 基础练习
#### 1.1 Java 

 类别 | 列1 | 列2 | 列3 | 列4 | 列5 
--- | --- | --- | --- | --- | --- 
Java | [Java 基础操练](https://github.com/hbulpf/JavaPrinciple) | [JavaEE](https://github.com/RunAtWorld/JavaEETest)
Spring | [Spring Demo](https://github.com/hbulpf/spring01-demo) | 
MyBatis| [Spring MyBatis Demo](https://github.com/RunAtWorld/springboot04-mybatis-demo) | [Spring MyBatisPlus Demo](https://github.com/RunAtWorld/springboot05-MybatisPlus-Demo) | [文档资料](https://down.51cto.com/data/2081927) / [视频教程](http://edu.51cto.com/course/course_id-1354.html)
Android | [AndroidOfferKiller](https://github.com/Blankj/AndroidOfferKiller)

#### 1.2 GO

类别 | 列1 | 列2 | 列3 | 列4 
--- | --- | --- | --- | ---
GOLang | [GoLang入门](https://github.com/RunAtWorld/golang_faq) | [GolangTraining](https://github.com/RunAtWorld/GolangTraining) | [Go Web](https://github.com/RunAtWorld/build-web-application-with-golang)
函数库 |[GoLang标准库](https://github.com/RunAtWorld/The-Golang-Standard-Library-by-Example) | [go-restful](https://github.com/RunAtWorld/go-restful)
项目 | [bbs-go](https://github.com/RunAtWorld/bbs-go)
工具 | [goproxy](https://github.com/RunAtWorld/goproxy)

#### 1.3 Python

类别 | 列1
--- | --- 
Python | [Python 100 Days](https://github.com/RunAtWorld/Python-100-Days) | [Python常用Sample](https://github.com/RunAtWorld/Python) |
项目 | [python-spider](https://github.com/RunAtWorld/python-spider) | [知乎爬虫](https://github.com/RunAtWorld/Zhihu_bigdata)

#### 1.4 算法
 类别 | 列1 | 列2 
--- | ---  | --
算法 | [各种语言的各种算法](https://github.com/TheAlgorithms) | [javascript-algorithms](https://github.com/RunAtWorld/javascript-algorithms)
leetcode | [leetcode](https://github.com/RunAtWorld/leetcode) | [java-leetcode](https://github.com/RunAtWorld/awesome-java-leetcode) | [leetbook](https://github.com/RunAtWorld/leetbook)
acm | [ACM-Code](https://github.com/RunAtWorld/ACM-Code)

#### 1.5 数据库

 类别 | 列1 
--- | --- 
mysql | [Mysql](./开发/mysql/)

#### 1.6 前端

 类别 | 列1 
--- | --- 
教程 | [前端教程](https://github.com/hbulpf/Web)
vue | [vue-demo](https://github.com/RunAtWorld/vue-demo) 

#### 1.7 其他
 类别 | 列1 | 列2 | 列3 
--- | --- | --- | --- 
IOT | [物联网入门](https://github.com/RunAtWorld/IoT-Firstep)| [awesome-iot](https://github.com/phodal/awesome-iot)| [iot最小系统](https://github.com/RunAtWorld/iot) | 
Quant | [EliteQuant](https://github.com/RunAtWorld/EliteQuant)

# 2. Dev/Ops
### 2.1 命令与应用

OS | 列1 | 列2 | 列3 | 列4 | 列5 
--- | --- | --- | --- | --- | --- 
Linux | [Linux 命令与应用](https://github.com/hbulpf/LinuxFun) | [Linux服务器运维脚本](https://github.com/hbulpf/ServerOps) | [shell](https://github.com/RunAtWorld/shell) | [the-art-of-command-line](https://github.com/RunAtWorld/the-art-of-command-line)
Windows | [Windows 常用命令](./开发/winDos.md)

### 2.2 开发相关

+ 版本控制&团队协作
	- [svn 常用指令](./开发/svn_cmd.md)
	- [git 常用指令](./工具/git/gitcmd.md)  /  [git 官方中文教程](https://git-scm.com/book/zh/v2) 
	
+ [开发技术与框架](开发/)
	- [Java 开发](./开发/java/)
		+ [maven 命令](./开发/java/maven/mavencmd.md) / [maven仓库配置](./开发/java/maven/maven_setting.xml)
		+ 日志: [logback](./开发/java/logback/logback.md)

+ 开发人员工具

用途 | 列1 | 列2 | 列3 
 --- | --- | --- | ---
接口设计 |  [swagger](./工具/swagger/README.md)
开发工具 | [IdeaJ](工具/IDEAJ/Idea.md)
版本控制 | [Git](./工具/git/gitcmd.md) | [SVN](./开发svn_cmd.md)	
文档写作 | [Markdown](工具/markdown/markdown.md) | [GitBook](工具/gitbook/gitbook.md) | [绘图工具](工具/painting/painting.md)

### 2.3 效率提升利器

类别 | 列1 | 列2 | 列3 | 列4 | 列5
 --- | --- | --- | ---| ---| ---
工具类 | [站长工具](https://tool.lu/) | [前端开发网站导航](https://nav.web-hub.cn/) | [MiKuTools](https://tool.imiku.me/) | [atoolbox](http://www.atoolbox.net/) | [toolnb](https://www.toolnb.com/)
教程类 | [菜鸟教程](https://www.runoob.com/)
其他 | [在线制作Logo](https://logoly.pro)
项目集合 | [GitHub-Chinese-Top-Charts](https://github.com/RunAtWorld/GitHub-Chinese-Top-Charts) | [Google Tools](https://github.com/RunAtWorld/xg2xg)

### 2.4 面试相关

类别 | 列1 | 列2 | 列3
--- | --- | --- | ---
笔试 | [写简历](https://github.com/RunAtWorld/resume-1)
技术面 | [秋招笔记](https://github.com/RunAtWorld/Interview-Notebook) | [`sre/ops` 技术面试](./面试/sre.md)
hr | [hr面试](./面试/hr.md) 

# 3. 云计算
1. Docker与Kubernetes

类别 | 列1 | 列2 | 列3 | 列4 
---  | --- | --- | --- | ---
Docker | [Docker 实验室](https://github.com/RunAtWorld/dockerlab) | [docker-pytorch](https://github.com/RunAtWorld/docker-pytorch)
K8S | [K8S 入门](https://github.com/RunAtWorld/k8spath) | [基于容器的弹性大数据平台](https://github.com/hbulpf/HSDocker) | [K8S examples](https://github.com/RunAtWorld/examples) | [《Kubernetes权威指南 第2版》源代码](https://github.com/RunAtWorld/k8s_2th_guide_code)
云存储 | [Ceph 运行维护手册/集群自动化脚本](https://github.com/RunAtWorld/ceph_manual)

# 4. 大数据

类别 | 列1 | 列2 | 列3 
--- | --- | --- | ---
大数据 | [大数据架构师应掌握的技能](https://github.com/RunAtWorld/big_data_architect_skills) | 

## 4.1 Hadoop生态
1. Hadoop
1. Hive
1. Pig
1. HBase
1. Spark

## 4.2 Hadoop相关部署工具
1. [hdp](https://hortonworks.com/downloads/#data-platform)
1. [cdh](https://www.cloudera.com/products/open-source/apache-hadoop/key-cdh-components.html)
1. [ambari](https://ambari.apache.org/)

# 5. 机器学习

1. [机器学习仓库](./ml/README.md)
2. [AiLearning](https://github.com/apachecn/AiLearning)

## 5.1 Tensorflow

类别 | 列1 | 列2 | 列3 
--- | --- | --- | ---
教程 | [Tensorflow教程](https://github.com/RunAtWorld/Tensorflow-Tutorial) | [tensorflow](https://github.com/RunAtWorld/tensorflow)
项目 | [docker-tensorflow-inception](https://github.com/RunAtWorld/bitnami-docker-tensorflow-inception)


# 6. 其他
## 6.1. 常用软件资源

镜像源           | 列1
------------    | -------------
[网易开源镜像站](http://mirrors.163.com)  | 
[清华大学开源软件镜像站](https://mirrors.tuna.tsinghua.edu.cn) | 
[中科大开源软件镜像站](http://mirrors.ustc.edu.cn/)  | 
[阿里巴巴开源软件镜像站](http://mirrors.aliyun.com/)  | 

 [更多开源镜像资源...](./mirrors.md)


## 6.2 进阶之路
1. [重点看的书](./BookList.md)
2. 大学的课程
   - [中国科学技术大学课程资源](https://github.com/USTC-Resource/USTC-Course)
   - [上海交通大学课程资料分享](https://github.com/CoolPhilChen/SJTU-Courses/)
   - [清华大学计算机系课程攻略](https://github.com/PKUanonym/REKCARC-TSC-UHT)
   - [浙江大学课程攻略共享计划](https://github.com/QSCTech/zju-icicles)
   - [北京大学课程资料整理](https://github.com/lib-pku/libpku)
3. [apachecn](https://github.com/apachecn/home)
4. [MLBooks](https://github.com/hbulpf/MLBooks)

## 6.3 其他

1. [问问题的礼仪](其他/How-To-Ask-Questions-The-Smart-Way.md)
2. 生活

类别 | 列1 | 列2 | 列3 
--- | --- | --- | ---
出行 | [12306](https://github.com/RunAtWorld/12306)
买卖 | [房价预测](https://github.com/RunAtWorld/HousePricing) | [如何买房](https://github.com/houshanren/hangzhou_house_knowledge)

3. [程序员职业病](./其他/程序员职业病.md)



----------------------------------------

**项目规范**

本文使用 [`Markdown`](https://www.markdownguide.org/basic-syntax) 编写, 排版符合[`中文技术文档写作规范`](https://github.com/hbulpf/document-style-guide)。Find Me On [**Github**](https://github.com/hbulpf/devbook) , [**Gitee**](https://gitee.com/sifangcloud/devbook)

**友情贡献**

@[**RunAtWorld**](http://www.github.com/RunAtWorld)  &nbsp;  @[**persuez**](https://github.com/persuez)

